Logo AND Algorithmique Numérique Distribuée

Public GIT Repository
b6a7ec5339bc0ecc52363f284d1b75828e8c1564
[simgrid.git] / src / smpi / smpirun.in
1 #! /bin/sh
2
3 # Copyright (c) 2007-2016, The SimGrid Team. All rights reserved.
4
5 # This program is free software; you can redistribute it and/or modify it
6 # under the terms of the license (GNU LGPL) which comes with this package.
7
8 @CMAKE_SMPI_COMMAND@
9
10 SIMGRID_VERSION="@SIMGRID_VERSION_STRING@"
11 SIMGRID_GITHASH="@SIMGRID_GITHASH@"
12
13 DEFAULT_LOOPBACK_BANDWIDTH="498000000Bps"
14 DEFAULT_LOOPBACK_LATENCY="0.000004s"
15 DEFAULT_NETWORK_BANDWIDTH="$((26 * 1024 * 1024))Bps"
16 DEFAULT_NETWORK_LATENCY="0.000005s"
17 DEFAULT_NUMPROCS="4"
18 DEFAULT_SPEED="100flops"
19
20 LOOPBACK_BANDWIDTH="${DEFAULT_LOOPBACK_BANDWIDTH}"
21 LOOPBACK_LATENCY="${DEFAULT_LOOPBACK_LATENCY}"
22 NETWORK_BANDWIDTH="${DEFAULT_NETWORK_BANDWIDTH}"
23 NETWORK_LATENCY="${DEFAULT_NETWORK_LATENCY}"
24 SPEED="${DEFAULT_SPEED}"
25
26 PRIVATIZE="--cfg=smpi/privatize-global-variables:@HAVE_PRIVATIZATION@"
27
28 SIMOPTS="--cfg=surf/precision:1e-9 --cfg=network/model:SMPI --cfg=network/TCP-gamma:4194304"
29
30 #usage to print the way this script should be called
31 usage () {
32     cat <<EOF
33 Usage: $0 [OPTIONS] -platform <xmldesc> -hostfile <hostfile> program [program-options]
34 Options:
35   -keep-temps                # don't remove the generated files after execution
36   -wrapper <command>         # use command to run the program (e.g. "valgrind")
37   -map                       # display the machine on which each process rank is mapped
38   -np <numprocs>             # use that amount of processes from the hostfile.
39                              # By default, all processes of the hostfile are used.
40   -no-privatize              # Disable the globals privatization, that is activated by default
41   -trace-ti                  # activate time independant tracing (for replay, default in smpi_simgrid.txt)
42   -trace                     # activate tracing (Paje, default in smpi_simgrid.trace)
43   -trace-comment <comment>   # put a comment on the top of the trace file
44   -trace-comment-file <file> # put file contents on the top of the trace file as comment
45   -trace-grouped             # group MPI processes by location
46   -trace-resource            # trace resource utilization
47   -trace-viva                # generate configuration for Viva's GraphView
48   -trace-file <tracefile>    # name of the tracefile (simgrid_smpi.trace)
49   -ext <value>               # additional parameter (reserved)
50
51   -version                   # Displays the SimGrid version (human readable)
52   -git-version               # Displays the git hash of SimGrid
53
54 or (deprecated usage):
55   $0 [-keep-temps] [-np <numprocs>] [-bandwidth <bytes/sec>] [-latency <secs>] program [program-options]
56
57 EOF
58 }
59
60 #check if we have at least one parameter
61 if [ $# -eq 0 ]
62 then
63     usage
64     exit
65 fi
66
67 EXTOPT=""
68 WRAPPER=""
69 HOSTFILE=""
70 HOSTFILETMP=0
71 MAPOPT=0
72 REPLAY=0
73
74 unset pid
75
76 trapped_signals="HUP INT QUIT ILL ABRT SEGV FPE ALRM TERM USR1 USR2 BUS"
77
78 smpirun_cleanup()
79 {
80   if [ -z "${KEEP}" ] ; then
81       if [ -z "${PLATFORM}" -a -n "$PLATFORMTMP" ]; then
82         rm -f ${PLATFORMTMP}
83         PLATFORMTMP=""
84       fi
85       if [ ${HOSTFILETMP} = 1 -a -n "$HOSTFILE" ] ; then
86           rm -f ${HOSTFILE}
87           HOSTFILE=""
88       fi
89       if [ ${UNROLLEDHOSTFILETMP} = 1 -a -n "$UNROLLEDHOSTFILE" ] ; then
90           rm -f ${UNROLLEDHOSTFILE}
91           UNROLLEDHOSTFILE=""
92       fi
93       if [ -n ${APPLICATIONTMP} ]; then
94         rm -f ${APPLICATIONTMP}
95         APPLICATIONTMP=""
96       fi
97   fi
98 }
99
100 smpirun_trap() {
101   local sig
102   sig="$1"
103
104   # Cleanup and kill the child process:
105   smpirun_cleanup
106   if ! [ -z "$pid" ]; then
107     kill -TERM $pid
108   fi
109   unset pid
110
111   # Raise the same signal again (remove the traps first):
112   trap - $trapped_signals
113   kill -$sig $$
114
115   # This should never happen:
116   kill -ABRT $$
117   kill -TERM $$
118 }
119
120 for s in $trapped_signals; do
121   trap "smpirun_trap $s" $s
122 done
123
124 while true; do
125     case "$1" in
126         "-np" | "-n")
127             NUMPROCS="$2"
128             shift 2
129             ;;
130         "-bandwidth")
131             NETWORK_BANDWIDTH="$2"
132             shift 2
133             ;;
134         "-latency")
135             NETWORK_LATENCY="$2"
136             shift 2
137             ;;
138         "-platform")
139             PLATFORM="$2"
140             if [ ! -f "${PLATFORM}" ]; then
141                 echo "[`basename $0`] ** error: the file '${PLATFORM}' does not exist. Aborting."
142                 exit 1
143             fi
144             shift 2
145             ;;
146         "-hostfile")
147             HOSTFILE="$2"
148             if [ ! -f "${HOSTFILE}" ]; then
149                 echo "[`basename $0`] ** error: the file '${HOSTFILE}' does not exist. Aborting."
150                 exit 1
151             fi
152             shift 2
153             ;;
154         "-machinefile")
155             HOSTFILE="$2"
156             if [ ! -f "${HOSTFILE}" ]; then
157                 echo "[`basename $0`] ** error: the file '${HOSTFILE}' does not exist. Aborting."
158                 exit 1
159             fi
160             shift 2
161             ;;
162         "-ext")
163             EXTOPT="$2"
164             shift 2
165             ;;
166         "-no-privatize")
167             PRIVATIZE=""
168             shift 1
169             ;;
170         "-map")
171             MAPOPT=1
172             shift 1
173             ;;
174         "-trace")
175             TRACE_ACTIVE="true"
176             shift 1
177             ;;
178         "-trace-ti")
179             TRACE_ACTIVE="true"
180             TRACE_TI_ACTIVE="true"
181             shift 1
182             ;;
183         "-trace-comment")
184             TRACE_COMMENT="$2"
185             shift 2
186             ;;
187         "-trace-comment-file")
188             TRACE_COMMENT_FILE="$2"
189             shift 2
190             ;;
191         "-trace-file")
192             TRACE_FILENAME="$2"
193             shift 2
194             ;;
195         "-trace-grouped")
196             TRACE_GROUPED="true"
197             shift 1
198             ;;
199         "-trace-resource")
200             TRACE_RESOURCE="true"
201             shift 1
202             ;;
203         "-trace-viva")
204             TRACE_VIVA="true"
205             shift 1
206             ;;
207         "-keep-temps")
208             KEEP="true"
209             shift 1
210             ;;
211         "-wrapper")
212             WRAPPER="$2"
213             shift 2
214             ;;
215         "-help" | "--help" | "-h")
216             usage
217             exit 0
218             ;;
219         "-version" | "--version" | "-v")
220             printf '%b\n' "$SIMGRID_VERSION"
221             exit 0
222             ;;
223         "-git-version" | "--git-version")
224             printf '%b\n' "$SIMGRID_GITHASH"
225             exit 0
226             ;;
227         "--cfg="*|"--log="*)
228             for OPT in ${1#*=}
229             do
230                 SIMOPTS="$SIMOPTS ${1%%=*}=$OPT"
231             done
232             shift 1
233             ;;
234         "-foreground")
235             # Nothing to do, compatibility.
236             shift 1
237             ;;
238         *)
239             break
240             ;;
241     esac
242 done
243
244 # check if we still have at least one parameter beyond options
245 if [ $# -eq 0 ]
246 then
247     echo "Error: no program to execute!"
248     usage
249     exit
250 fi
251
252 EXEC="$1"
253 shift
254
255 # steel --cfg and --logs options
256 while [ $# -gt 0 ]; do
257     case "$1" in
258         "--cfg="*|"--log="*)
259             for OPT in ${1#*=}
260             do
261                 SIMOPTS="$SIMOPTS ${1%%=*}=$OPT"
262             done
263             shift 1
264             ;;
265         *)
266             PROC_ARGS="${PROC_ARGS:+$PROC_ARGS }$1"
267             shift      
268             ;;
269     esac
270 done
271
272 if [ -z "${HOSTFILE}" ] && [ -z "${PLATFORM}" ] ; then
273     echo "No hostfile nor platform specified."
274     usage
275     exit 1
276 fi
277
278 if [ -z "${HOSTFILE}" ] ; then
279     HOSTFILETMP=1
280     HOSTFILE="$(mktemp smpitmp-hostfXXXXXX)"
281     perl -ne 'print "$1\n" if /.*<host.*?id="(.*?)".*?\/>.*/' ${PLATFORM} > ${HOSTFILE}
282     perl -ne 'if (/.*<cluster.*?prefix="(.*?)".*?radical="(.*?)".*?suffix="(.*?)".*/) { 
283                 my ($pre,$rad,$post)=($1,$2,$3); 
284                 for my $elm (split(",",$rad)) { 
285                   if ($elm=~/^([^-]*?)-([^-]*)$/) { 
286                      for (my $i=$1; $i<=$2;$i++) { 
287                         print "$pre$i$post\n"; 
288                      }
289                   } else {
290                      print "$pre$elm$post\n";
291                   }
292                 }
293               } elsif (/<cluster/) {
294             die ("Unparsable cluster tag. smpirun uses a primitive regular expression to parse cluster tags. Either provide a hostfile yourself or give the attributes prefix, radical and suffix IN THAT ORDER and ON THE SAME LINE as the opening tag (<cluster)");
295               }' ${PLATFORM} >> ${HOSTFILE}
296 fi
297 UNROLLEDHOSTFILETMP=0
298
299 #parse if our lines are terminated by :num_process
300 multiple_processes=`grep -c ":" $HOSTFILE`
301 if [ "${multiple_processes}" -gt 0 ] ; then
302     UNROLLEDHOSTFILETMP=1
303     UNROLLEDHOSTFILE="$(mktemp smpitmp-hostfXXXXXX)"
304     perl -ne ' do{ for ( 1 .. $2 ) { print "$1\n" } } if /(.*?):(\d+).*/'  ${HOSTFILE}  > ${UNROLLEDHOSTFILE}
305     if [ ${HOSTFILETMP} = 1 ] ; then
306         rm ${HOSTFILE}
307         HOSTFILETMP=0
308     fi
309     HOSTFILE=$UNROLLEDHOSTFILE
310 fi
311
312 # Don't use wc -l to compute it to avoid issues with trailing \n at EOF
313 hostfile_procs=`grep -c "[a-zA-Z0-9]" $HOSTFILE`
314 if [ ${hostfile_procs} = 0 ] ; then
315    echo "[`basename $0`] ** error: the hostfile '${HOSTFILE}' is empty. Aborting." >&2
316    exit 1
317 fi
318
319 if [ -z "${NUMPROCS}" ] ; then
320     # Use the amount of processes in the hostfile as default value for the -np parameter
321     NUMPROCS=$hostfile_procs
322 fi
323
324 if [ ${NUMPROCS} -gt ${hostfile_procs} ] ; then
325     echo "You requested to use ${NUMPROCS} processes, but there is only ${hostfile_procs} processes in your hostfile..." >&2
326 fi
327
328 ##-------------------------------- DEFAULT or SPECIFIED PLATFORM --------------------------------------
329 if [ -z "${PLATFORM}" ]; then
330     PLATFORMTMP="$(mktemp smpitmp-platfXXXXXX)"
331
332     cat > ${PLATFORMTMP} <<PLATFORMHEAD
333 <?xml version='1.0'?>
334 <!DOCTYPE platform SYSTEM "http://simgrid.gforge.inria.fr/simgrid/simgrid.dtd">
335 <platform version="4">
336 <AS id="AS0" routing="Full">
337 PLATFORMHEAD
338
339     i=${NUMPROCS}
340     while [ $i -gt 0 ]; do
341         echo "  <host id=\"host$i\" speed=\"${SPEED}\"/>" >> ${PLATFORMTMP}
342         echo "  <link id=\"loop$i\" bandwidth=\"${LOOPBACK_BANDWIDTH}\" latency=\"${LOOPBACK_LATENCY}\"/>" >> ${PLATFORMTMP}
343         echo "  <link id=\"link$i\" bandwidth=\"${NETWORK_BANDWIDTH}\" latency=\"${NETWORK_LATENCY}\"/>" >> ${PLATFORMTMP}
344         i=$((i - 1))
345     done
346
347     i=${NUMPROCS}
348     while [ $i -gt 0 ]; do
349         j=${NUMPROCS}
350         while [ $j -gt 0 ]; do
351             if [ $i -eq $j ]; then
352                 echo "  <route src=\"host$i\" dst=\"host$j\"><link_ctn id=\"loop$i\"/></route>" >> ${PLATFORMTMP}
353             else
354                 echo "  <route src=\"host$i\" dst=\"host$j\"><link_ctn id=\"link$i\"/><link_ctn id=\"link$j\"/></route>" >> ${PLATFORMTMP}
355             fi
356             j=$((j - 1))
357         done
358         i=$((i - 1))
359     done
360
361     cat >> ${PLATFORMTMP} <<PLATFORMFOOT
362 </AS>
363 </platform>
364 PLATFORMFOOT
365
366 else
367     PLATFORMTMP=${PLATFORM}
368 fi
369 ##-------------------------------- end DEFAULT or SPECIFIED PLATFORM --------------------------------------
370 ##-------------------------------- DEFAULT APPLICATION --------------------------------------
371 APPLICATIONTMP="$(mktemp smpitmp-appXXXXXX)"
372 #APPLICATIONTMP="app.xml"
373
374 cat > ${APPLICATIONTMP} <<APPLICATIONHEAD
375 <?xml version='1.0'?>
376 <!DOCTYPE platform SYSTEM "http://simgrid.gforge.inria.fr/simgrid/simgrid.dtd">
377 <platform version="4">
378 APPLICATIONHEAD
379
380 ##---- cache hostnames of hostfile---------------
381 if [ -n "${HOSTFILE}" ] && [ -f ${HOSTFILE} ]; then
382     hostnames=$(cat ${HOSTFILE} | tr '\n\r' '  ')
383 fi
384
385 if [ "${EXTOPT}" = "smpi_replay" ]; then
386     APP_TRACES=$PROC_ARGS
387     if [ -n "${APP_TRACES}" ] && [ -f "${APP_TRACES}" ]; then
388         hosttraces=$(cat ${APP_TRACES} | tr '\n\r' '  ' )
389         NUMTRACES=$(cat ${APP_TRACES} | wc -l)
390         REPLAY=1
391     else
392         printf "File not found: %s\n" "${APP_TRACES:-\${APP_TRACES\}}" >&2
393         exit 1
394     fi
395 fi
396
397 ##----------------------------------------------------------
398 ##  generate application.xml with hostnames from hostfile:
399 ##  the name of host_i (1<=i<=p, where -np p) is the line i in hostfile (where -hostfile hostfile), or "host$i" if 
400 ##  hostfile has less than i lines.
401 ##----------------------------------------------------------
402
403 HAVE_SEQ="`which seq 2>/dev/null`"
404
405 if [ -n "${HAVE_SEQ}" ]; then
406     SEQ=`${HAVE_SEQ} 0 $((${NUMPROCS}-1))`
407 else
408     cnt=0
409     while [ $cnt -lt ${NUMPROCS} ] ; do
410         SEQ="$SEQ $cnt"
411         cnt=$((cnt + 1));
412     done
413 fi
414
415 set -- $hostnames
416
417 ##---- generate <process> tags------------------------------
418 #prepare arguments at once
419 for ARG in $PROC_ARGS; do
420   XML_ARGS="${XML_ARGS}""<argument value=\"${ARG}\"/>
421 "
422 done
423
424 for i in ${SEQ}
425 do
426     j=$(( $i % ${hostfile_procs} + 1 ))
427     host=$(eval "echo \${$j}")
428
429     ##---- optional display of ranks to process mapping
430     if [ ${MAPOPT} = 1 ]; then
431       echo "[rank $i] -> $host"
432     fi
433
434     echo "  <process host=\"${host}\" function=\"$i\"> <!-- function name used only for logging -->
435     <argument value=\"1\"/> <!-- instance -->
436     <argument value=\"$i\"/> <!-- rank -->" >> ${APPLICATIONTMP}
437     if [ ${REPLAY} = 1 ]; then
438         if  [ ${NUMTRACES} -gt 1 ]; then
439             echo "    <argument value=\"$(echo $hosttraces|cut -d' ' -f$j)\"/>" >> ${APPLICATIONTMP}
440         else
441             echo "    <argument value=\"$(echo $hosttraces|cut -d' ' -f1)\"/>" >> ${APPLICATIONTMP}
442         fi
443     else 
444     echo ${XML_ARGS} >> ${APPLICATIONTMP}
445     fi
446     echo "  </process>" >> ${APPLICATIONTMP}
447 done
448
449 cat >> ${APPLICATIONTMP} <<APPLICATIONFOOT
450 </platform>
451 APPLICATIONFOOT
452 ##-------------------------------- end DEFAULT APPLICATION --------------------------------------
453 ##---------------------- SMPI TRACING OPTIONS ---------------------------------
454 if [ -n "${TRACE_ACTIVE}" ]; then
455     #define trace filename
456     if [ -n "${TRACE_TI_ACTIVE}" ]; then
457         if [ -z "${TRACE_FILENAME}" ]; then
458             TRACE_FILENAME="smpi_simgrid.txt"
459         fi
460         TRACEOPTIONS="--cfg=tracing:yes --cfg=tracing/filename:${TRACE_FILENAME} --cfg=tracing/smpi:yes --cfg=tracing/smpi/format:TI --cfg=tracing/smpi/computing:yes"
461     else
462         if [ -z "${TRACE_FILENAME}" ]; then
463             TRACE_FILENAME="smpi_simgrid.trace"
464         fi
465         TRACEOPTIONS="--cfg=tracing:yes --cfg=tracing/filename:${TRACE_FILENAME} --cfg=tracing/smpi:yes"
466     fi
467
468     if [ -n "${TRACE_COMMENT}" ]; then
469         TRACEOPTIONS="${TRACEOPTIONS} --cfg=tracing/comment:${TRACE_COMMENT}"
470     fi
471
472     if [ -n "${TRACE_COMMENT_FILE}" ]; then
473         TRACEOPTIONS="${TRACEOPTIONS} --cfg=tracing/comment-file:${TRACE_COMMENT_FILE}"
474     fi
475
476     if [ -n "${TRACE_GROUPED}" ]; then
477         TRACEOPTIONS="${TRACEOPTIONS} --cfg=tracing/smpi/group:yes"
478     fi
479
480     if [ -n "${TRACE_RESOURCE}" ]; then
481         TRACEOPTIONS="${TRACEOPTIONS} --cfg=tracing/categorized:yes --cfg=tracing/uncategorized:yes"
482     fi
483
484     if [ -n "${TRACE_VIVA}" ]; then
485         TRACEOPTIONS="${TRACEOPTIONS} --cfg=viva/categorized:smpi_cat.plist --cfg=viva/uncategorized:smpi_uncat.plist"
486     fi
487 fi
488 ##---------------------- end SMPI TRACING OPTIONS ---------------------------------
489
490 export SMPI_GLOBAL_SIZE=${NUMPROCS}
491 if [ -n "${KEEP}" ] ; then
492     echo ${EXEC} ${PRIVATIZE} ${TRACEOPTIONS} ${SIMOPTS} ${PLATFORMTMP} ${APPLICATIONTMP}
493     if [ ${HOSTFILETMP} = 1 ] ; then
494         echo "Generated hostfile ${HOSTFILE} kept."
495     fi
496     if [ ${UNROLLEDHOSTFILETMP} = 1 ] ; then
497         echo "Generated unrolled hostfile ${UNROLLEDHOSTFILE} kept." 
498     fi
499 fi
500
501 # Execute the process
502 #
503 # The shell still need to be alive for the duration in order to do some cleanup after the process.
504 #
505 # We are going through great lengths in order to both keep stdin and be able to handle signals:
506 #
507 # * The job is launched in the background in order to be able to handle signals.
508 #
509 # * The FD 3 is used to temporarily store FD 1. This is because the shell connects FD 1 to /dev/null when the command
510 #   is launched in the background: this can be overriden in bash but not in standard bourne shell.
511 exec 3<&0
512 ${WRAPPER} "@SMPIMAIN@" ${EXEC} ${TRACEOPTIONS} ${SIMOPTS} ${PLATFORMTMP} ${APPLICATIONTMP} <&3 3>&- &
513 pid=$!
514 exec 3>&-
515 wait $pid
516 status=$?
517 pid=""
518
519 # Keep temporary files on failures to help debugging
520 #
521 if [ ${status} -ne 0 ] ; then
522     if [ -z ${KEEP} ]; then
523         echo ${EXEC} ${PRIVATIZE} ${TRACEOPTIONS} ${SIMOPTS} ${PLATFORMTMP} ${APPLICATIONTMP}
524         if [ ${HOSTFILETMP} = 1 ] ; then
525             echo "Generated hostfile ${HOSTFILE} kept."
526         fi
527         if [ ${UNROLLEDHOSTFILETMP} = 1 ] ; then
528             echo "Generated unrolled hostfile ${UNROLLEDHOSTFILE} kept."
529         fi
530     fi
531     echo "Execution failed with code ${status}."
532     KEEP=true
533 fi
534
535 smpirun_cleanup
536
537 exit $status